new, 600000;

open f1=c:\papers\arch\feb2002\ed1;

col_year  =2;					
col_dif   =3;
cold_dif  =4;

x      =readr(f1,rowsf(f1));
f1     =close(f1);

numyear=maxc(x[.,col_year])-minc(x[.,col_year])+1;      @SET NUMBER OF YEARS IN DATASET @
y      =rows(x)-numyear+1;		

dif	   =zeros(numyear-1,numyear-1);
d_dif  =zeros(numyear-1,numyear-1);

for i(1,y,numyear);
		dif_j  =x[i+1:i+numyear-1,col_dif]*x[i+1:i+numyear-1,col_dif]';
		d_dif_j=x[i+1:i+numyear-1,cold_dif]*x[i+1:i+numyear-1,cold_dif]';
		dif =dif+dif_j;
		d_dif=d_dif+d_dif_j;
		clear dif_j,d_dif_j;
endfor;

dif     =dif./d_dif;

c=vech(dif);
d=vech(d_dif);

dim    =(rows(dif)*(rows(dif)+1))/2;

omega  =zeros(dim,dim);

for i(1,y,numyear);
		c_j=x[i+1:i+numyear-1,col_dif]*x[i+1:i+numyear-1,col_dif]';
		d_j=x[i+1:i+numyear-1,cold_dif]*x[i+1:i+numyear-1,cold_dif]';
		c_j=vech(c_j);
		d_j=vech(d_j);
		clear all_matrix_j,all_d_matrix_j;
		omega=omega+(((c_j-c)*(c_j-c)').*(d_j*d_j'));
		clear c_j,d_j;
endfor;
omega=omega./(d*d');
moments=c~omega~(numyear*ones(rows(c),1));

yy=saved(moments,"c:\\papers\\arch\\feb2002\\edu1",0);

end;
system;