new, 600000;

open f1=c:\papers\arch\feb2002\ed;

col_year  =2;					
col_dif   =3;
cold_dif  =4;

x      =readr(f1,rowsf(f1));
f1     =close(f1);

numyear=maxc(x[.,col_year])-minc(x[.,col_year])+1;      @SET NUMBER OF YEARS IN DATASET @
y      =rows(x)-numyear+1;		

dif	   =zeros(numyear-1,numyear-1);
d_dif  =zeros(numyear-1,numyear-1);

for i(1,y,numyear);
		dif_j  =x[i+1:i+numyear-1,col_dif]*x[i+1:i+numyear-1,col_dif]';
		d_dif_j=x[i+1:i+numyear-1,cold_dif]*x[i+1:i+numyear-1,cold_dif]';
		dif =dif+dif_j;
		d_dif=d_dif+d_dif_j;
		clear dif_j,d_dif_j;
endfor;

dif     =dif./d_dif;

c=vech(dif);
d=vech(d_dif);

dim    =(rows(dif)*(rows(dif)+1))/2;

omega  =zeros(dim,dim);

for i(1,y,numyear);
		c_j  =x[i+1:i+numyear-1,col_dif]*x[i+1:i+numyear-1,col_dif]';
		d_j=x[i+1:i+numyear-1,cold_dif]*x[i+1:i+numyear-1,cold_dif]';
		c_j=vech(c_j);
		d_j=vech(d_j);
		clear all_matrix_j,all_d_matrix_j;
		omega=omega+(((c_j-c)*(c_j-c)').*(d_j*d_j'));
		clear c_j,d_j;
endfor;
omega=omega./(d*d');
moments=c~omega~(numyear*ones(rows(c),1));

yy=saved(moments,"c:\\papers\\arch\\feb2002\\edu",0);

z      =band(dif,cols(dif)-1);
m	   =z[1:rows(z),cols(z)];

i	   =2;
j      =numyear-1;
do 	   while (i<=numyear-1);
			m=m|z[i:numyear-1,j-1];
		i=i+1;
		j=j-1;
endo;
clear z;

z       =band(d_dif,cols(d_dif)-1);
d       =z[1:rows(z),cols(z)];

i       =2;
j       =numyear-1;
do      while (i<=numyear-1);
			d=d|z[i:numyear-1,j-1];
		i=i+1;
		j=j-1;
endo;
clear z;

d       =d*d';

omega   =zeros(dim,dim);

i       =1;
do 		while (i<=y);
			mi=x[i+1:i+numyear-1,col_dif]*x[i+1:i+numyear-1,col_dif]';
			di=x[i+1:i+numyear-1,cold_dif]*x[i+1:i+numyear-1,cold_dif]';

				zm=band(mi,cols(mi)-1);
					mi=zm[1:rows(zm),cols(zm)];
					k=2;
					j=numyear-1;
					do while (k<=numyear-1);
						mi=mi|zm[k:numyear-1,j-1];
						k=k+1;
						j=j-1;
					endo;
				clear zm;

				zd=band(di,cols(di)-1);
					di=zd[1:rows(zd),cols(zd)];
					k=2;
					j=numyear-1;
					do while (k<=numyear-1);
						di=di|zd[k:numyear-1,j-1];
						k=k+1;
						j=j-1;
					endo;
				clear zd;

			omega=omega+(((mi-m)*(mi-m)').*(di*di'));

			clear mi,di;
		i=i+numyear;
endo;

clear x;

omega   =omega./d;

omegad  =sqrt(diag(omega));
tstat   =zeros(dim,1);
		
		for i (1,dim,1);
		tstat[i,1]=m[i,1]/omegad[i,1];
		endfor;

output file=c:\papers\arch\feb2002\moment.out reset;

m~omegad~tstat;

output file=c:\papers\arch\feb2002\zero.out reset;

i=1;
do 	   while (i<=4);
	dimzero     =((numyear-i-1)*(numyear-i))/2;
	zero_restr  =zeros(dimzero,dim-dimzero)~eye(dimzero);
	m2          =zero_restr*m;
	omega22     =omega[dim-dimzero+1:rows(omega),dim-dimzero+1:cols(omega)];
	testzero    =m2'*inv(omega22)*m2;
	pvaltestzero=cdfchic(testzero,rows(zero_restr));
	dof=rows(zero_restr);
	i~testzero~pvaltestzero~dof;
    	i=i+1;
endo;

end;
system;